<id>
Shows latest posts in Infocenter
</id>

<version>
1.0
</version>

<mod info>
Shows the latest posts in Infocenter. (like SMF)
MBCO2 compatible version
</mod info>

<author>
Zoo
</author>

###########################

<edit file>
Sources/Sublist.pl
</edit file>

<search for>
'recent',"Recent.pl&RecentPosts",
</search for>

<add after>
'recentpostlist',"Recent.pl&RecentPostList",
</add after>

###########################

<edit file>
English.lng
</edit file>

<search for>
1;
</search for>

<add before>
$recenttxt{'1'} = "most recent posts";
$recenttxt{'2'} = "more recent posts";

</add before>

###########################

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
        <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td>
      </tr>~;
</search for>

<add after>
### Recent Topics List
	$Show_RecentPostList=5;
	if($Show_RecentPostList>0) {
		require "$sourcedir/Recent.pl";
		&RecentPostList($Show_RecentPostList);
	}
</add after>

###########################

<edit file>
Sources/Recent.pl
</edit file>

<search for>
1;
</search for>

<add before>

sub RecentPostList {
	my $display = $_[0];
	if ( $display ) { $look = 'bindex'; }
	else {
		$look = 'simple';

		# Get number of topics
		$display = $INFO{'display'} ||= 50;
		if ( $display < 0 ) { $display=50; }
		elsif ( $display > 500 ) { $display = 500; }
	}

	my( @memset, @categories, %data, $numfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );
	$numfound=0;

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####

			fopen(FILE, "$boardsdir/$curboard.txt");
			for ($i = 0; $i < $display && ($buffer = <FILE>); $i++) {
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $buffer );
				$mtime = stringtotime($tdate);
				$data[$numfound] = "$mtime|$curboard|$tnum|$treplies";
				$numfound++;
			}
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;
		}
	}

	@data = reverse sort @data;
	$numfound=0;

	$threadfound = @data > $display ? $display : @data;

	for ($i = 0; $i < $threadfound; $i++) {
		($mtime, $curboard, $tnum, $treplies) = split( /\|/, $data[$i] );

		fopen(FILE, "$datadir/$tnum.txt") || next;
		@mess = <FILE>;
		fclose(FILE);

		$threadfrom = @mess > $display ? @mess-$display : 0;
		for ($ii = $threadfrom; $ii < @mess+1; $ii++) {
			#chomp $mess[$ii];
			if( $mess[$ii] ) {
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$mess[$ii]);
				$mtime = stringtotime($mdate);
				$messages[$numfound] = "$mtime|$curboard|$tnum|$ii|$msub|$mname|$mdate|$musername";
				$numfound++;
			}
		}
	}

	@messages = reverse sort @messages;

	if( $numfound>$display ) { $numfound=$display; }

	# Load Censor List
	&LoadCensorList;
	$counter = 1;

	if ( $look eq 'bindex') {
$yymain .= qq~
	<td align="left" class="catbg" colspan="2"> <font class="catbg"><b>$display $recenttxt{'1'}</b></font></td>
         </tr><tr>
           <td class="windowbg" width="20" valign="middle" align="center"><img src="$imagesdir/xx.gif" border="0" alt="" /></td>
           <td class="windowbg2" valign="top" align="center">
            <table width="98%"  align="center">
              </tr>
~;
		for( $i = 0; $i < $numfound; $i++ ) {
			($mtime, $board, $tnum, $c, $msub, $mname, $mdate, $musername) = split( /\|/, $messages[$i] );

			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
	 			$message =~ s~\Q$tmpa\E~$tmpb~gi;
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			&wrap;
			if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
				&LoadUser($musername);
				$mname = exists $userprofile{$musername} ? $userprofile{$musername}->[1] : $mname;
				$mname ||= $txt{'470'};
				$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" alt="$txt{'27'}: $musername">$mname</a>~;
			}
			$mdate = &timeformat($mdate);
$yymain .= qq~
              <tr>
              <td align="right" valign="top" nowrap="nowrap"><font size="1">[ $boardinfo{$board}->[0] ] </td>
              <td valign="top"><font size="1"><a href="$scripturl?board=$board;action=display;num=$tnum;start=$c#$c" class="nav" target="_parent">$msub</a> ($txt{'525'} $mname)</td>
              <td align="left" valign="top" nowrap="nowrap"><font size="1">$mdate</td>
              </tr>
~;
			++$counter;
		}
$yymain .= qq~
             </tr>	
            </table>
~;
		if ($counter == 1) {$yymain .= qq~ <br /><b>$txt{'170'}</b><br />~; }
		else { $yymain .= qq~            <font size="1"><a href="$scripturl?action=recentpostlist;display=50" target="_parent">$recenttxt{'2'}</a>~; }
$yymain .= qq~

           </td>
	  </tr>
~;
	}
	else {

$yymain .= qq~
    <table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
      <tr>
        <td class="titlebg" align="center" colspan="2">
        <font class="text1"><b>$display $recenttxt{'1'}</b></font></td>
      </tr>
      <tr>
        <td class="windowbg2" valign="top" align="center">
        <table width="98%" cellpadding="2" align="center">
~;
		for( $i = 0; $i < $numfound; $i++ ) {
			($mtime, $board, $tnum, $c, $msub, $mname, $mdate, $musername) = split( /\|/, $messages[$i] );
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			&wrap;

			if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
				&LoadUser($musername);
				$mname = exists $userprofile{$musername} ? $userprofile{$musername}->[1] : $mname;
				$mname ||= $txt{'470'};
				$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" title="$maintxt{'27'}: $musername">$mname</a>~;
			}
			$mdate = &timeformat($mdate);
$yymain .= qq~
          <tr>
              <td align="right" valign="top" nowrap="nowrap"><font size="1">$counter.</td>
              <td align="right" valign="top" nowrap="nowrap"><font size="1">[ $boardinfo{$board}->[0] ] </td>
              <td valign="top"><font size="1"><a href="$scripturl?board=$board;action=display;num=$tnum;start=$c#$c" class="nav" target="_parent">$msub</a> ($txt{'525'} $mname)</td>
              <td align="left" valign="top" nowrap="nowrap"><font size="1">$mdate</td>
          </tr>
~;
			++$counter;
		}
	if ($counter == 1) {$yymain .= qq~ <br /><b>$txt{'170'}</b><br />~; }

$yymain .= qq~
        </table>
      </table><br />
~;
	$yytitle = "$display $recenttxt{'1'}";
	&template;
	exit;
	}
}
</add before>
